function MyMenuCardapioController(ScreenService, templateManager, restEngine, LocalPlateDataService, MessageService) {
    var self = this;
    this.doNothing = function () {};
    this.onEnter = function (widget) {};
    
    function saveCons(data) {
        return restEngine.request("/consSave", {
            requestType: "Row",
            row: data
        }).promise.catch(erro => self.trataErrosReserva(erro));
    }

    function removeCons(data) {
        return restEngine.request("/consRemove", {
            requestType: "Row",
            row: data
        });
    }

    function saveSrvCons(data) {
        return restEngine.request("/consSrvSave", {
            requestType: "Row",
            row: data
        }).promise.catch(erro => self.trataErrosReserva(erro));
    }

    function save(data) {
        return restEngine.request("/rateSave", {
            requestType: "Row",
            row: data
        });
    }
    

    this.resetBookMarking = function(widget) {
        widget.bookMarking = [];
        widget.reload();
    };
    
    this.backToLastWidget = function (widget) {
        let widgets = widget.container.widgets;
        let acwidget = widgets.indexOf(widget);

        widget.isVisible = false;

        let widgetToGo = widgets[acwidget - 1];

        widgetToGo.container.label = widgetToGo.servdata ? widgetToGo.servdata[widgetToGo.label] : null || widgetToGo.currentRow.servdata ? widgetToGo.currentRow.servdata[widgetToGo.label] : widgetToGo.label;

        widgetToGo.isVisible = true;
        widgetToGo.activate();
    };

    this.saveRateData = function () {

        let widget = templateManager.container.getActiveWidget();
        let dtfil = widget.dataSourceFilter.find(f => f.name === 'DTCARDAPIO').value;
        dtfil = dtfil === "@moment().format('DD/MM/YYYY')@" ? moment() : moment(dtfil, 'DD/MM/YYYY');

        let plate = widget.plateToRate;
        plate.NRUSUARIOAPP = getLocalVar('userData').NRUSUARIOAPP;
        plate.NRORG = getLocalVar('userData').NRORG;
        plate.VRAVALIACAOPRATO = plate.newAv;
        plate.DTCARDAPIO = dtfil.format('DD/MM/YYYY');

        save(plate).then(response => {
            if (getLocalVar('userData').isAnon && getLocalVar('userData').isAnon === true) {
                if (getLocalVar('lastRate')) {
                    let list = getLocalVar('lastRate');
                    let last = {
                        'CDPRATO': plate.CDPRATO,
                        'NRCARDAPIO': plate.NRCARDAPIO,
                        'CDTIPOPRAT': plate.CDTIPOPRAT,
                        'DATE': dtfil.format('DD/MM/YYYY')
                    };
                    list.push(last);
                    setLocalVar('lastRate', list);
                } else {
                    let last = {
                        'CDPRATO': plate.CDPRATO,
                        'NRCARDAPIO': plate.NRCARDAPIO,
                        'CDTIPOPRAT': plate.CDTIPOPRAT,
                        'DATE': dtfil.format('DD/MM/YYYY')
                    };
                    setLocalVar('lastRate', [last]);
                }
            }
            widget.reload();
            MessageService.showMessageByCode('MSG_RATED_WITH_SUCCESS', null, {type: 'success'});
        }).catch(error => {
            ScreenService.showMessage(error || error.message || 'Erro!');
        });
        widget.plateToRate = null;
    };

    this.resetTitle = () => templateManager.container.label = ScreenService.i18n('CARDÁPIO');

    function getFormatedPlateForCons(plate) {
        return {
            'CDPRATO': plate.CDPRATO,
            'CDFILCENTPME': plate.CDFILCENTPME,
            'CDTIPOCARD': plate.CDTIPOCARD,
            'NRCARDPME': plate.NRCARDPME,
            'CDDIETPAD': plate.CDDIETPAD,
            'CDFILIAL': plate.CDFILIAL,
            'CDSERVFILI': plate.CDSERVFILI,
            'NRCARDAPIO': plate.NRCARDAPIO,
            'NRSEQPRATCAR': plate.NRSEQPRATCAR,
            'CDFILAUXPRAT': plate.CDFILAUXPRAT,
            'DTCARDAPIO': plate.DTCARDAPIO,
            'CDTIPOPRAT': plate.CDTIPOPRAT,
            'IDCONSUMO': plate.IDCONSUMO,
            'NMUSUARIO': plate.NMUSUARIO,
            'HRCONSUMO': plate.HRCONSUMO,
            'NRORG': plate.NRORG,
            'DSCONSUMO': plate.DSCONSUMO || "",
            
            IDOPCCNFMES: plate.IDOPCCNFMES,
            IDCONCNFMES: plate.IDCONCNFMES
        };
    }

    function getFormatedServiceForCons(service) {
        return {
            'IDCONSUMO': service.IDCONSUMO,
            'DTCARDAPIO': service.DTCARDAPIO,
            'CDFILIAL': service.CDFILIAL,
            'CDSERVFILI': service.CDSERVFILI,
            'CDTIPOCARD': service.CDTIPOCARD,
            'NMUSUARIO': service.NMUSUARIO,
            'HRCONSUMO': service.HRCONSUMO,
            'NRORG': service.NRORG
        };
    }

    function editLocalConsData(plate) {
        let savedCons = getLocalVar('savedCons');
        if (savedCons) {
            let consToUpdate = savedCons.find(sc => sc.CDPRATO == plate.CDPRATO && sc.CDFILCENTPME == plate.CDFILCENTPME && sc.CDTIPOCARD == plate.CDTIPOCARD && sc.NRCARDPME == plate.NRCARDPME && sc.CDDIETPAD == plate.CDDIETPAD && sc.CDFILIAL == plate.CDFILIAL && sc.CDSERVFILI == plate.CDSERVFILI && sc.NRCARDAPIO == plate.NRCARDAPIO && sc.NRSEQPRATCAR == plate.NRSEQPRATCAR && sc.CDFILAUXPRAT == plate.CDFILAUXPRAT && sc.CDPRATO == plate.CDPRATO && sc.DTCARDAPIO == plate.DTCARDAPIO && sc.CDTIPOPRAT == plate.CDTIPOPRAT && sc.NRORG == plate.NRORG);
            if (consToUpdate) {
                consToUpdate.IDCONSUMO = plate.IDCONSUMO;
                consToUpdate.NMUSUARIO = plate.NMUSUARIO;
                consToUpdate.HRCONSUMO = plate.HRCONSUMO;
            } else {
                savedCons.push(getFormatedPlateForCons(plate));
            }
        } else {
            savedCons = [];
            savedCons.push(getFormatedPlateForCons(plate));
        }
        setLocalVar('savedCons', savedCons);
    }

    function editLocalSrvConsData(service) {
        let savedCons = getLocalVar('savedSrvCons');
        if (savedCons) {
            let consToUpdate = savedCons.find(sc => sc.CDFILIAL == service.CDFILIAL && sc.CDSERVFILI == service.CDSERVFILI && sc.CDTIPOCARD == service.CDTIPOCARD && sc.DTCARDAPIO == service.DTCARDAPIO && sc.NRORG == service.NRORG);
            if (consToUpdate) {
                consToUpdate.IDCONSUMO = service.IDCONSUMO;
                consToUpdate.NMUSUARIO = service.NMUSUARIO;
                consToUpdate.HRCONSUMO = service.HRCONSUMO;
            } else {
                savedCons.push(getFormatedServiceForCons(service));
            }
        } else {
            savedCons = [];
            savedCons.push(getFormatedServiceForCons(service));
        }
        setLocalVar('savedSrvCons', savedCons);
    }

    function saveIDCONCNFMES(plate) {
        let savedIDCONCNFMES = getLocalVar('IDCONCNFMESLIST');
        if (plate.IDCONCNFMES == 'S') {
            if (savedIDCONCNFMES) {
                savedIDCONCNFMES = savedIDCONCNFMES.filter(sicm => !(plate.CDTIPOPRAT == sicm.CDTIPOPRAT && plate.NRCARDAPIO == sicm.NRCARDAPIO && plate.CDPRATO == sicm.CDPRATO));
                if (plate.IDCONSUMO == 'S') {
                    savedIDCONCNFMES.push(plate);
                }
            } else {
                savedIDCONCNFMES = [];
                savedIDCONCNFMES.push(plate);
            }
        }
        setLocalVar('IDCONCNFMESLIST', savedIDCONCNFMES);
    }

    this.deleteConsData = function () {
        let widget = templateManager.container.getActiveWidget();
        const isAnon = getLocalVar('userData').isAnon;
        let plates = [];
        plates = angular.copy(widget.dataSource.data.filter((data) => data.IDCONSUMO == 'S'));
        
        plates.forEach((plate, key) => {
            plate.IDCONSUMO = 'N';
            plate.NRORG = getLocalVar('userData').NRORG;
            plate.isAnon = isAnon;
            plate.NRUSUARIOAPP = getLocalVar('userData').NRUSUARIOAPP;
            plate.HRCONSUMO = plate.isAnon ? null : plate.HRCONSUMO.replace(':', '');
            plate.DTCARDAPIO = plate.DTCARDAPIO === "@moment().format('DD/MM/YYYY')@" ? moment().format('DD/MM/YYYY') : plate.DTCARDAPIO;
            if (plate.isAnon) {
                plate.NRUSUARIOAPP = null;
                LocalPlateDataService.reloadCache();
                const localPlate = plate.IDCONSUMO === 'N' ?  LocalPlateDataService.findPlate(plate) : plate;
                if(localPlate)
                    plates[key] = Object.assign(plate, localPlate);
                plate.IDCONSUMO = 'N';
                editLocalConsData(plate);
            }
            saveIDCONCNFMES(plate);
        });
        
        saveCons(plates).then(() => {
            MessageService.successNotificationByCode('MSG_CANCEL_RESERVATION');
            //Atualiza cache de pratos
            LocalPlateDataService.reloadCache();
            widget.reload();
        });
    };

    this.saveConsData = function () {
        let widget = templateManager.container.getActiveWidget();
        let plates = widget.bookMarking;

        if(plates && plates.length > 0) {
            const nmTpPratoCons = this.checkCons(widget);
            if(nmTpPratoCons == '') {
                plates.forEach((plate) => {
                    plate.NRORG = getLocalVar('userData').NRORG;
                    plate.isAnon = getLocalVar('userData').isAnon;
                    plate.NRUSUARIOAPP = getLocalVar('userData').NRUSUARIOAPP;
                    plate.HRCONSUMO = widget.dataBookmarking.HRCONSUMO.replace(':', '');
                    plate.DTCARDAPIO = plate.DTCARDAPIO === "@moment().format('DD/MM/YYYY')@" ? moment().format('DD/MM/YYYY') : plate.DTCARDAPIO;
                    if (plate.isAnon) {
                        plate.NRUSUARIOAPP = null;
                        LocalPlateDataService.reloadCache();
                        const localPlate = plate.IDCONSUMO === 'N' ?  LocalPlateDataService.findPlate(plate) : plate;
                        if(localPlate)
                            plate = Object.assign(localPlate, plate);
                        editLocalConsData(plate);
                    }
                    saveIDCONCNFMES(plate);
                });
                saveCons(plates).then(() => {
                    MessageService.successNotificationByCode('MSG_CONFIRMED_RESERVATION');
                    widget.bookMarking = [];
                    widget.doReservation = false;
                    //Atualiza cache de pratos
                    LocalPlateDataService.reloadCache();
                    widget.reload();
                    
                });
            } else {
                MessageService.showMessageByCode('MSG_SELECT_AT_LEAST_ONE', {PARAM: nmTpPratoCons}, {type:'error'});
                widget.doReservation = false;
                widget.dataBookmarking.HRCONSUMO = null;
            }
            
        }
    };

    this.checkCons = function(widget) {
        let nmTpPratoCons = '';
        let cdtpPrato = widget.dataSource.data.map((cdprato) => cdprato.CDTIPOPRAT);
        cdtpPrato = [...new Set(cdtpPrato)];
        cdtpPrato.forEach((cdprato) => {
            const arrObject = widget.dataSource.data.filter((data) => data.CDTIPOPRAT == cdprato && data.IDCONCNFMES == 'S');
            if(arrObject.length > 0) {
                const selectedPratCons = arrObject.filter((object) => object.IDCONSUMO == 'S');
                if (selectedPratCons.length == 0) {
                    nmTpPratoCons = arrObject[0].NMTIPOPRAT;
                    return;
                }
            }
        });
        return nmTpPratoCons;
    };

    this.saveSrvConsData = function () {
        let widget = templateManager.container.getActiveWidget();
        let servdata = widget.dataBookmarking;

        let dtfil = widget.dataSourceFilter.find(f => f.name === 'DTCARDAPIO').value;
        dtfil = dtfil === "@moment().format('DD/MM/YYYY')@" ? moment() : moment(dtfil, 'DD/MM/YYYY');
        servdata.DTCARDAPIO = dtfil.format('DD/MM/YYYY');

        servdata.NRORG = getLocalVar('userData').NRORG;
        servdata.isAnon = getLocalVar('userData').isAnon;
        servdata.NRUSUARIOAPP = getLocalVar('userData').NRUSUARIOAPP;
        if (servdata.isAnon) {
            servdata.NRUSUARIOAPP = null;
            editLocalSrvConsData(servdata);
        }
        saveSrvCons(servdata).then(() => {
            widget.dataBookmarking = null;
            widget.reload();
        });
    };
    
    this.trataErrosReserva = function(erro){
        if(erro && erro.data && erro.data.error){
            if(erro.data.error.search('RESERVA_JA_REALIZADA_USUARIO') >= 0){
                MessageService.successNotificationByCode('RESERVA_JA_REALIZADA_USUARIO');
            }
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('MyMenuCardapioController', MyMenuCardapioController);
});