/* global getLocalVar BroadcastChannel Configuration */
const FirebaseMessageController = function ( MessageService, engine ){
	function logout( data ){
		const CURRENT_USER = (getLocalVar('userData') || {}).NRUSUARIOAPP;
		if(!data || !data.NRUSUARIOAPP || data.NRUSUARIOAPP !== CURRENT_USER) return null;
		MessageService.showMessageByCode( data.TYPE );
		return engine.forceLogOut();
	}
	function onMessage( event ){
		const message = event.detail;
		if( message && message.TYPE ) {
			switch( message.TYPE ) {
				case 'MSG_DEACTIVATED_USER': return logout(message);
				default: return null;
			}
		}
	}
	document.addEventListener('notificationopen', onMessage);
	
	(function enterBroadcastChannel(){
		if( 'BroadcastChannel' in window ) {
	        const broadcast = new BroadcastChannel('firebase-browser');
	        broadcast.onmessage = ( event ) => {
	            const { data } = event.data;
	            onMessage({detail: data});
	        };
		}
    })();
};
Configuration(function(ContextRegister){
	ContextRegister.register("FirebaseMessageController", FirebaseMessageController);
});
